diff -r 0e86e50bebeb -r eea535071231 libgui/src/property-inspector-table.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/libgui/src/property-inspector-table.h	Tue Nov 10 00:52:22 2020 +0100
@@ -0,0 +1,200 @@
+////////////////////////////////////////////////////////////////////////
+//
+// Copyright (C) 2013-2020 The Octave Project Developers
+//
+// See the file COPYRIGHT.md in the top-level directory of this
+// distribution or <https://octave.org/copyright/>.
+//
+// This file is part of Octave.
+//
+// Octave is free software: you can redistribute it and/or modify it
+// under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Octave is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Octave; see the file COPYING.  If not, see
+// <https://www.gnu.org/licenses/>.
+//
+////////////////////////////////////////////////////////////////////////
+
+#if !defined(octave_property_inspector_table_h)
+#define octave_property_inspector_table_h 1
+
+#include <memory>
+
+#include <QAbstractTableModel>
+#include <QStyledItemDelegate>
+#include <QWidget>
+
+#include "Matrix.h"
+
+#include "graphics-handle.h"
+#include "graphics.h"
+
+class QGridLayout;
+class QTableView;
+
+class color_property;
+
+class Ui_color_editor_widget;
+
+namespace octave
+{
+  class base_qobject;
+
+  class go_properties_table_model : public QAbstractTableModel
+  {
+    Q_OBJECT
+
+  public:
+    go_properties_table_model (QObject *p, base_qobject &oct_qobj,
+                               const graphics_object &go);
+    ~go_properties_table_model ();
+
+    int columnCount (const QModelIndex &parent = QModelIndex{}) const override;
+
+    int rowCount (const QModelIndex &parent = QModelIndex{}) const override;
+
+    QModelIndex index (int row, int column,
+                       const QModelIndex &parent) const override;
+
+    Qt::ItemFlags flags (const QModelIndex &index) const override;
+
+    QVariant headerData (int section, Qt::Orientation orientation,
+                         int role) const override;
+
+    QVariant data (const QModelIndex &index, int role) const override;
+
+    bool setData (const QModelIndex &indes, const QVariant &value,
+                  int role) override;
+
+  private:
+    base_qobject &m_oct_qobj;
+    graphics_object m_go;
+
+    std::vector<std::string> m_names;
+  };
+
+  class go_properties_item_delegate : public QStyledItemDelegate
+  {
+    Q_OBJECT
+  public:
+    go_properties_item_delegate (QObject *parent, base_qobject &oct_qobj,
+                                 QTableView *view);
+    ~go_properties_item_delegate () = default;
+
+    // painting
+    void paint (QPainter *painter, const QStyleOptionViewItem &option,
+                const QModelIndex &index) const override;
+    QSize sizeHint (const QStyleOptionViewItem &option,
+                    const QModelIndex &index) const override;
+
+    // editing
+    QWidget *createEditor (QWidget *parent, const QStyleOptionViewItem &option,
+                           const QModelIndex &index) const override;
+
+    void setEditorData (QWidget *editor,
+                        const QModelIndex &index) const override;
+
+    void setModelData (QWidget *editor, QAbstractItemModel *model,
+                       const QModelIndex &index) const override;
+
+    void updateEditorGeometry (QWidget *editor,
+                               const QStyleOptionViewItem &option,
+                               const QModelIndex &index) const override;
+
+    void destroyEditor (QWidget *editor,
+                        const QModelIndex &index) const override;
+
+  signals:
+
+    void layoutWillChange (int row) const;
+
+  private:
+    void resize_editor_cell (QWidget *editor, const QModelIndex &index) const;
+
+    base_qobject &m_oct_qobj;
+    QTableView *m_view;
+    mutable QSize m_former_size;
+  };
+
+  // widget to edit (small) matrix and arrays
+  class matrix_widget : public QWidget
+  {
+    Q_OBJECT
+  public:
+    matrix_widget (QWidget *parent, const Matrix &matrix);
+
+    virtual ~matrix_widget () = default;
+
+    void set (const Matrix &matrix);
+    Matrix get (bool *ok = nullptr) const;
+
+  private:
+    QGridLayout *m_layout;
+  };
+
+  class color_editor_val
+  {
+  public:
+    enum value_type
+    {
+      STR,
+      RGB,
+    };
+
+    color_editor_val (const std::string &str);
+    color_editor_val (const Matrix &rgb);
+
+    value_type type () const { return m_type; }
+    std::string string_value () const;
+    Matrix rgb_value () const;
+
+  private:
+    value_type m_type;
+    std::string m_str;
+    Matrix m_rgb;
+  };
+
+  class color_editor_widget : public QWidget
+  {
+    Q_OBJECT
+  public:
+    color_editor_widget (QWidget *parent, const color_property *prop);
+    virtual ~color_editor_widget ();
+
+    void set (const color_editor_val &val);
+    color_editor_val get () const;
+
+  signals:
+    void rgb_changed (const QColor &rgb);
+
+  private:
+    enum class rgb_source
+    {
+      spinbox,
+      octave,
+      svg,
+      other,
+    };
+
+  private slots:
+    void set_rgb (const QColor &color, rgb_source source = rgb_source::other);
+    void handle_rgb_mat_change ();
+    void handle_rgb_octave_color_change ();
+    void handle_rgb_svg_change ();
+    void handle_rgb_pick ();
+
+  private:
+    Ui_color_editor_widget *ui;
+  };
+
+}
+
+#endif
diff -r 0e86e50bebeb -r eea535071231 libgui/src/property-inspector-tree.cc
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/libgui/src/property-inspector-tree.cc	Tue Nov 10 00:52:22 2020 +0100
@@ -0,0 +1,345 @@
+////////////////////////////////////////////////////////////////////////
+//
+// Copyright (C) 2013-2020 The Octave Project Developers
+//
+// See the file COPYRIGHT.md in the top-level directory of this
+// distribution or <https://octave.org/copyright/>.
+//
+// This file is part of Octave.
+//
+// Octave is free software: you can redistribute it and/or modify it
+// under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Octave is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Octave; see the file COPYING.  If not, see
+// <https://www.gnu.org/licenses/>.
+//
+////////////////////////////////////////////////////////////////////////
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <algorithm>
+#include <vector>
+
+#include <QThread>
+
+#include "caseless-str.h"
+
+#include "graphics.h"
+#include "interpreter.h"
+
+#include "octave-qobject.h"
+#include "qt-application.h"
+
+#include "property-inspector-tree.h"
+
+namespace octave
+{
+
+  using node_ref = std::shared_ptr<pi_tree_node>;
+
+  // a node corresponding to a single graphics object
+  class pi_tree_node : public std::enable_shared_from_this<pi_tree_node>
+  {
+  public:
+    pi_tree_node (const graphics_object& gobj, int row,
+                  const node_ref& parent = nullptr)
+        : m_gh{ gobj.get_handle () }, m_row{ row }, m_parent{ parent }
+    {
+    }
+
+    // not in ctor because we need shared_from_this
+    void prepare (gh_manager& gh_mgr)
+    {
+      auto obj = gh_mgr.get_object (m_gh);
+
+      m_type = QString::fromStdString (obj.type ());
+
+      Matrix kids = obj.get_properties ().get_children ();
+      for (octave_idx_type i = 0; i < kids.numel (); ++i)
+        {
+          const auto kid = gh_mgr.get_object (kids (i));
+          if (!kid)
+            continue;
+
+          const auto r = static_cast<int> (m_children.size ());
+          const auto c
+              = std::make_shared<pi_tree_node> (kid, r, shared_from_this ());
+          c->prepare (gh_mgr);
+          m_children.push_back (c);
+        }
+    }
+
+    node_ref parent () const { return m_parent.lock (); }
+    graphics_handle handle () const { return m_gh; }
+    int row () const { return m_row; }
+    QString type () const { return m_type; }
+
+    const std::vector<node_ref>& children () const { return m_children; }
+
+    node_ref lookup (const graphics_object& go)
+    {
+      if (go.get_handle () == m_gh)
+        return shared_from_this ();
+      for (const auto& c : m_children)
+        {
+          auto n = c->lookup (go);
+          if (n)
+            return n;
+        }
+      return nullptr;
+    }
+
+    node_ref add_child (const node_ref& node)
+    {
+      m_children.push_back (node);
+      return node;
+    }
+
+    void rem_child (const node_ref& node)
+    {
+      if (node->row () >= static_cast<int> (m_children.size ()))
+        {
+          // error
+        }
+      if (m_children[node->row ()] != node)
+        {
+          // error
+        }
+      auto it = std::begin (m_children) + node->row ();
+      m_children.erase (it);
+      // reindex lower children
+      for (int r = node->row (); r < static_cast<int> (m_children.size ());
+           ++r)
+        {
+          m_children[r]->m_row = r;
+        }
+    }
+
+  private:
+    graphics_handle m_gh;
+    int m_row;
+    QString m_type;
+    std::weak_ptr<pi_tree_node> m_parent;
+    std::vector<node_ref> m_children;
+  };
+
+  go_tree_model::go_tree_model (QObject* p, base_qobject& oct_qobj)
+      : QAbstractItemModel (p), m_oct_qobj{ oct_qobj }
+  {
+    auto gh_mgr = oct_qobj.interpreter_qobj ()->get_gh_manager ();
+
+    graphics_object root = gh_mgr->get_object (0);
+
+    initialize (*gh_mgr, root);
+  }
+
+  go_tree_model::go_tree_model (QObject* p, base_qobject& oct_qobj,
+                                const graphics_object& root)
+      : QAbstractItemModel (p), m_oct_qobj{ oct_qobj }
+  {
+    auto gh_mgr = oct_qobj.interpreter_qobj ()->get_gh_manager ();
+
+    initialize (*gh_mgr, root);
+  }
+
+  void go_tree_model::initialize (gh_manager& gh_mgr,
+                                  const graphics_object& root)
+  {
+    if (!root)
+      {
+        throw new std::logic_error (
+            "go_tree_model::initialize: invalide root");
+      }
+
+    auto events = m_oct_qobj.get_qt_interpreter_events ();
+
+    QObject::connect (events.get (), &qt_interpreter_events::go_created, this,
+                      &go_tree_model::add_graphics_object);
+
+    QObject::connect (events.get (), &qt_interpreter_events::go_will_delete,
+                      this, &go_tree_model::rem_graphics_object);
+
+    m_root = std::make_shared<pi_tree_node> (root, 0);
+    m_root->prepare (gh_mgr);
+  }
+
+  go_tree_model::~go_tree_model () {}
+
+  QModelIndex go_tree_model::index (int row, int column,
+                                    const QModelIndex& parent) const
+  {
+    auto pnode = get_node (parent);
+    if (!pnode)
+      {
+        // root index
+        return node_index (m_root, column);
+      }
+    else
+      {
+        const auto& children = pnode->children ();
+        if (row >= 0 && row < static_cast<int> (children.size ()))
+          {
+            const auto child = children[row];
+            return node_index (child, column);
+          }
+      }
+    return QModelIndex{};
+  }
+
+  QModelIndex go_tree_model::parent (const QModelIndex& index) const
+  {
+    const auto node = get_node (index);
+    if (node)
+      return node_index (node->parent ());
+    return QModelIndex{};
+  }
+
+  int go_tree_model::columnCount (const QModelIndex&) const { return 2; }
+
+  int go_tree_model::rowCount (const QModelIndex& parent) const
+  {
+    const auto pnode = get_node (parent);
+    if (!pnode)
+      return m_root ? 1 : 0;
+    else
+      {
+        return static_cast<int> (pnode->children ().size ());
+      }
+  }
+
+  QVariant go_tree_model::headerData (int section, Qt::Orientation orientation,
+                                      int role) const
+  {
+    if (orientation != Qt::Horizontal)
+      return QVariant{};
+    if (role != Qt::DisplayRole)
+      return QVariant{};
+    switch (section)
+      {
+      case 0:
+        return "Handle type";
+      case 1:
+        return "Value";
+      default:
+        break;
+      }
+    return QVariant{};
+  }
+
+  QVariant go_tree_model::data (const QModelIndex& index, int role) const
+  {
+    const auto pnode = get_node (index);
+    if (!pnode)
+      return QVariant{};
+    if (role == Qt::DisplayRole)
+      {
+        switch (index.column ())
+          {
+          case 0:
+            return pnode->type ();
+          case 1:
+            return pnode->handle ().value ();
+          default:
+            break;
+          }
+      }
+    return QVariant{};
+  }
+
+  graphics_object go_tree_model::get_go_at (const QModelIndex& index) const
+  {
+
+    const auto node = get_node (index);
+    if (node)
+      {
+        auto gh_mgr = m_oct_qobj.interpreter_qobj ()->get_gh_manager ();
+        const auto gh = node->handle ();
+        return gh_mgr->get_object (gh);
+      }
+    return graphics_object{};
+  }
+
+  void go_tree_model::add_graphics_object (const graphics_object& go)
+  {
+    auto gh_mgr = m_oct_qobj.interpreter_qobj ()->get_gh_manager ();
+
+    const auto ph = go.get_parent ();
+    const auto pnode = lookup (gh_mgr->get_object (ph));
+    if (!pnode)
+      return;
+
+    const auto pindex = node_index (pnode);
+    const auto r = static_cast<int> (pnode->children ().size ());
+
+    beginInsertRows (pindex, r, r);
+
+    const auto node = std::make_shared<pi_tree_node> (go, r, pnode);
+    node->prepare (*gh_mgr);
+    pnode->add_child (node);
+
+    endInsertRows ();
+  }
+
+  void go_tree_model::rem_graphics_object (const graphics_object& go)
+  {
+    const auto node = lookup (go);
+    if (!node)
+      return;
+
+    const auto pnode = node->parent ();
+    const auto pindex = node_index (pnode);
+
+    if (!pnode)
+      throw std::logic_error ("go_tree_model::rem_graphics_object: "
+                              "parentless node");
+
+    beginRemoveRows (pindex, node->row (), node->row ());
+
+    pnode->rem_child (node);
+
+    endRemoveRows ();
+  }
+
+  QModelIndex
+  go_tree_model::node_index (const std::shared_ptr<pi_tree_node>& node,
+                             int column) const
+  {
+    if (!node)
+      return QModelIndex{};
+
+    return createIndex (node->row (), column,
+                        static_cast<void*> (node.get ()));
+  }
+
+  node_ref go_tree_model::get_node (const QModelIndex& index) const
+  {
+    if (!index.isValid ())
+      return nullptr;
+    if (!index.internalPointer ())
+      return nullptr;
+
+    return static_cast<pi_tree_node*> (index.internalPointer ())
+        ->shared_from_this ();
+  }
+
+  node_ref go_tree_model::lookup (const graphics_object& obj) const
+  {
+    if (!obj)
+      return nullptr;
+    if (!m_root)
+      return nullptr;
+
+    return m_root->lookup (obj);
+  }
+
+}
diff -r 0e86e50bebeb -r eea535071231 libgui/src/property-inspector-tree.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/libgui/src/property-inspector-tree.h	Tue Nov 10 00:52:22 2020 +0100
@@ -0,0 +1,89 @@
+////////////////////////////////////////////////////////////////////////
+//
+// Copyright (C) 2013-2020 The Octave Project Developers
+//
+// See the file COPYRIGHT.md in the top-level directory of this
+// distribution or <https://octave.org/copyright/>.
+//
+// This file is part of Octave.
+//
+// Octave is free software: you can redistribute it and/or modify it
+// under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Octave is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Octave; see the file COPYING.  If not, see
+// <https://www.gnu.org/licenses/>.
+//
+////////////////////////////////////////////////////////////////////////
+
+#if !defined(octave_property_inspector_tree_h)
+#define octave_property_inspector_tree_h 1
+
+#include <memory>
+
+#include <QAbstractTableModel>
+
+#include "graphics-handle.h"
+
+class gh_manager;
+class graphics_object;
+
+namespace octave
+{
+  class base_qobject;
+
+  class pi_tree_node;
+
+  class go_tree_model : public QAbstractItemModel
+  {
+    Q_OBJECT
+
+  public:
+    go_tree_model (QObject* p, base_qobject& oct_qobj);
+    go_tree_model (QObject* p, base_qobject& oct_qobj,
+                   const graphics_object& root);
+
+  private:
+    void initialize (gh_manager& gh_mgr, const graphics_object& root);
+
+  public:
+    virtual ~go_tree_model ();
+
+    QModelIndex index (int row, int column,
+                       const QModelIndex& parent) const override;
+    QModelIndex parent (const QModelIndex& index) const override;
+
+    int columnCount (const QModelIndex& parent) const override;
+
+    int rowCount (const QModelIndex& parent) const override;
+
+    QVariant headerData (int section, Qt::Orientation orientation,
+                         int role) const override;
+
+    QVariant data (const QModelIndex& index, int role) const override;
+
+    graphics_object get_go_at (const QModelIndex& index) const;
+
+  private slots:
+    void add_graphics_object (const graphics_object& go);
+    void rem_graphics_object (const graphics_object& go);
+
+  private:
+    base_qobject& m_oct_qobj;
+    std::shared_ptr<pi_tree_node> m_root;
+
+    QModelIndex node_index (const std::shared_ptr<pi_tree_node>& node,
+                            int column = 0) const;
+    std::shared_ptr<pi_tree_node> get_node (const QModelIndex& index) const;
+    std::shared_ptr<pi_tree_node> lookup (const graphics_object& obj) const;
+  };
+}
+
+#endif
diff -r 0e86e50bebeb -r eea535071231 libgui/src/property-inspector.cc
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/libgui/src/property-inspector.cc	Tue Nov 10 00:52:22 2020 +0100
@@ -0,0 +1,121 @@
+////////////////////////////////////////////////////////////////////////
+//
+// Copyright (C) 2013-2020 The Octave Project Developers
+//
+// See the file COPYRIGHT.md in the top-level directory of this
+// distribution or <https://octave.org/copyright/>.
+//
+// This file is part of Octave.
+//
+// Octave is free software: you can redistribute it and/or modify it
+// under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Octave is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Octave; see the file COPYING.  If not, see
+// <https://www.gnu.org/licenses/>.
+//
+////////////////////////////////////////////////////////////////////////
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <QHeaderView>
+#include <QSplitter>
+#include <QTableView>
+#include <QTreeView>
+
+#include "octave-qobject.h"
+#include "property-inspector-table.h"
+#include "property-inspector-tree.h"
+#include "property-inspector.h"
+#include "qt-application.h"
+
+namespace octave
+{
+
+  property_inspector::property_inspector (QWidget *p, base_qobject &oct_qobj)
+      : octave_dock_widget ("PropertyInspector", p, oct_qobj),
+        m_splitter (new QSplitter (Qt::Horizontal, this)),
+        m_tree (new QTreeView (this)), m_table (new QTableView (this)),
+        m_tree_model (nullptr), m_table_model (nullptr)
+  {
+    set_title (tr ("Property Inspector"));
+    setStatusTip (tr ("Inspect properties."));
+    setWindowIcon (QIcon (":/actions/icons/logo.png"));
+    setAttribute (Qt::WA_AlwaysShowToolTips);
+
+    m_splitter->addWidget (m_tree);
+    m_splitter->addWidget (m_table);
+    m_splitter->setChildrenCollapsible (true);
+
+    m_splitter->setSizes (QIntList{ 300, 600 });
+
+    setWidget (m_splitter);
+
+    m_table->setItemDelegate (
+        new go_properties_item_delegate (this, m_octave_qobj, m_table));
+
+    if (oct_qobj.app_context ().interpreter_initialized ())
+      {
+        initialize_models ();
+      }
+    else
+      {
+        QObject::connect (oct_qobj.interpreter_qobj (),
+                          &interpreter_qobject::ready, this,
+                          &property_inspector::initialize_models);
+      }
+  }
+
+  property_inspector::~property_inspector () = default;
+
+  void property_inspector::initialize_models ()
+  {
+    m_tree_model = new go_tree_model (this, m_octave_qobj);
+    auto *old_model = m_tree->model ();
+    m_tree->setModel (m_tree_model);
+    if (old_model)
+      delete old_model;
+
+    // give the first column some space
+    m_tree->header ()->resizeSection (0, 150);
+
+    QObject::connect (m_tree->selectionModel (),
+                      &QItemSelectionModel::currentChanged, this,
+                      &property_inspector::tree_current_changed);
+  }
+
+  void property_inspector::tree_current_changed (const QModelIndex &current,
+                                                 const QModelIndex &)
+  {
+    auto go = m_tree_model->get_go_at (current);
+    if (!go)
+      return;
+
+    auto *prev_model = m_table->model ();
+
+    auto new_model = std::make_unique<go_properties_table_model> (
+        nullptr, m_octave_qobj, go);
+
+    m_table->setModel (new_model.get ());
+    m_table->resizeColumnsToContents ();
+    m_table->resizeRowsToContents ();
+
+    if (prev_model && prev_model != m_table_model.get ())
+      {
+        // initial empty model placed by Qt - we don't need it anymore
+        delete prev_model;
+      }
+
+    m_table_model = std::move (new_model);
+  }
+
+}
diff -r 0e86e50bebeb -r eea535071231 libgui/src/property-inspector.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/libgui/src/property-inspector.h	Tue Nov 10 00:52:22 2020 +0100
@@ -0,0 +1,77 @@
+////////////////////////////////////////////////////////////////////////
+//
+// Copyright (C) 2013-2020 The Octave Project Developers
+//
+// See the file COPYRIGHT.md in the top-level directory of this
+// distribution or <https://octave.org/copyright/>.
+//
+// This file is part of Octave.
+//
+// Octave is free software: you can redistribute it and/or modify it
+// under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Octave is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Octave; see the file COPYING.  If not, see
+// <https://www.gnu.org/licenses/>.
+//
+////////////////////////////////////////////////////////////////////////
+
+#if !defined(octave_property_inspector_h)
+#  define octave_property_inspector_h 1
+
+#include <memory>
+
+#  include "octave-dock-widget.h"
+
+class QSplitter;
+class QTreeView;
+class QTableView;
+
+namespace octave
+{
+  class base_qobject;
+
+  class go_tree_model;
+  class go_properties_table_model;
+
+  class property_inspector : public octave_dock_widget
+  {
+    Q_OBJECT
+
+  public:
+    property_inspector (QWidget *parent, base_qobject &oct_qobj);
+
+    ~property_inspector ();
+
+    // No copying!
+
+    property_inspector (const property_inspector &) = delete;
+
+    property_inspector &operator= (const property_inspector &) = delete;
+
+  private slots:
+
+    // we need the interpreter ready, so we defer this to a slot.
+    void initialize_models ();
+
+    void tree_current_changed (const QModelIndex &current,
+                               const QModelIndex &previous);
+
+  private:
+    QSplitter *m_splitter;
+    QTreeView *m_tree;
+    QTableView *m_table;
+
+    go_tree_model *m_tree_model;
+    std::unique_ptr<go_properties_table_model> m_table_model;
+  };
+}
+
+#endif
diff -r 0e86e50bebeb -r eea535071231 libgui/src/qt-interpreter-events.cc
--- a/libgui/src/qt-interpreter-events.cc	Sun Oct 25 19:28:08 2020 -0700
+++ b/libgui/src/qt-interpreter-events.cc	Tue Nov 10 00:52:22 2020 +0100
@@ -568,6 +568,22 @@ namespace octave
     emit delete_debugger_pointer_signal (QString::fromStdString (file), line);
   }
 
+  void qt_interpreter_events::notify_go_created (const graphics_object& go)
+  {
+    emit go_created (go);
+  }
+
+  void qt_interpreter_events::notify_go_updated (const graphics_object& go,
+                                                 int prop_id)
+  {
+    emit go_updated (go, prop_id);
+  }
+
+  void qt_interpreter_events::notify_go_will_delete (const graphics_object& go)
+  {
+    emit go_will_delete (go);
+  }
+
   void
   qt_interpreter_events::confirm_shutdown_octave (void)
   {
diff -r 0e86e50bebeb -r eea535071231 libgui/src/qt-interpreter-events.h
--- a/libgui/src/qt-interpreter-events.h	Sun Oct 25 19:28:08 2020 -0700
+++ b/libgui/src/qt-interpreter-events.h	Tue Nov 10 00:52:22 2020 +0100
@@ -35,15 +35,22 @@
 #include <QString>
 #include <QWaitCondition>
 
+#include "event-manager.h"
+#include "graphics-handle.h"
+
 #include "dialog.h"
 #include "gui-settings.h"
 
-#include "event-manager.h"
-
 // Defined for purposes of sending QList<int> as part of signal.
 typedef QList<int> QIntList;
 
 class octave_value;
+class graphics_object;
+
+namespace QtHandles
+{
+  class qt_graphics_toolkit;
+}
 
 namespace octave
 {
@@ -176,6 +183,12 @@ namespace octave
     void update_breakpoint (bool insert, const std::string& file, int line,
                             const std::string& cond);
 
+    void notify_go_created(const graphics_object& go) override;
+
+    void notify_go_updated(const graphics_object& go, int prop_id) override;
+
+    void notify_go_will_delete(const graphics_object& go) override;
+
     void lock (void) { m_mutex.lock (); }
 
     void wait (void) { m_waitcondition.wait (&m_mutex); }
@@ -256,6 +269,12 @@ namespace octave
 
     void apply_new_settings (void);
 
+    void go_created (const graphics_object& go);
+
+    void go_updated (const graphics_object& go, int prop_id);
+
+    void go_will_delete (const graphics_object& go);
+
   private:
 
     QString gui_preference_adjust (const QString& key, const QString& value);
diff -r 0e86e50bebeb -r eea535071231 libinterp/corefcn/event-manager.h
--- a/libinterp/corefcn/event-manager.h	Sun Oct 25 19:28:08 2020 -0700
+++ b/libinterp/corefcn/event-manager.h	Tue Nov 10 00:52:22 2020 +0100
@@ -40,6 +40,7 @@
 
 class octave_value;
 class string_vector;
+class graphics_object;
 
 namespace octave
 {
@@ -241,6 +242,18 @@ namespace octave
     update_breakpoint (bool /*insert*/, const std::string& /*file*/,
                        int /*line*/, const std::string& /*cond*/)
     { }
+
+    virtual void
+    notify_go_created(const graphics_object& /*go*/)
+    { }
+
+    virtual void
+    notify_go_updated(const graphics_object& /*go*/, int /*prop_id*/)
+    { }
+
+    virtual void
+    notify_go_will_delete(const graphics_object& /*go*/)
+    { }
   };
 
   //! Provides threadsafe access to octave.
@@ -609,6 +622,24 @@ namespace octave
         instance->update_breakpoint (insert, file, line, cond);
     }
 
+    void notify_go_created (const graphics_object& go)
+    {
+      if (enabled ())
+        instance->notify_go_created(go);
+    }
+
+    void notify_go_updated (const graphics_object& go, int prop_id)
+    {
+      if (enabled ())
+        instance->notify_go_updated(go, prop_id);
+    }
+
+    void notify_go_will_delete (const graphics_object& go)
+    {
+      if (enabled ())
+        instance->notify_go_will_delete(go);
+    }
+
   private:
 
     interpreter& m_interpreter;
diff -r 0e86e50bebeb -r eea535071231 libinterp/corefcn/genprops.awk
--- a/libinterp/corefcn/genprops.awk	Sun Oct 25 19:28:08 2020 -0700
+++ b/libinterp/corefcn/genprops.awk	Tue Nov 10 00:52:22 2020 +0100
@@ -300,7 +300,7 @@ function emit_declarations ()
   if (class_name && ! base)
     emit_common_declarations();
 
-  printf ("public:\n\n\n  static std::set<std::string> core_property_names (void);\n\n  static std::set<std::string> readonly_property_names (void);\n\n  static bool has_core_property (const caseless_str& pname);\n\n  static bool has_readonly_property (const caseless_str& pname);\n\n  std::set<std::string> all_property_names (void) const;\n\n");
+  printf ("public:\n\n\n  static std::set<std::string> core_property_names (void);\n\n  static std::set<std::string> readonly_property_names (void);\n\n  static bool has_core_property (const caseless_str& pname);\n\n  static bool has_readonly_property (const caseless_str& pname);\n\n  virtual std::set<std::string> all_property_names (void) const;\n\n");
 
   if (! base)
     printf ("  bool has_property (const caseless_str& pname) const;\n\n");
